//  constants and declarations fot bogofilter

// constants for the Graham formula 
#define GOOD_BIAS	2		// give good words more weight
#define KEEPERS		15		// how many extrema to keep
#define MINIMUM_FREQ	5		// minimum freq
#define UNKNOWN_WORD	0.2f		// odds that unknown word is spammish
#define SPAM_CUTOFF	0.9f		// if it's spammier than this...
#define MAX_REPEATS	4		// max word repeats counted per message

// discard tokens longer than this, so as not to clutter up our
// wordlists with a lot of MIME-enclosure cruft.
#define MAXWORDLEN	20

typedef struct 
{
    char	key[MAXWORDLEN];
    double	prob;
}
discrim_t;

typedef struct
{
    double spamicity;
    discrim_t extrema[KEEPERS];
}
bogostat_t;

typedef struct 
{
    char *name;			// resource name (for debug/verbose messages)
    void *list;			// the Judy array
    unsigned long msgcount;	// count of messages in wordlist.
    unsigned long modcount;	// how many times this has been modified
    char *file;			// associated file
}
wordlist_t;

extern int read_list(char *file, wordlist_t *list);
extern void write_lists(void);
extern int getcount(char *word, wordlist_t *list);
extern void register_words(int fd, wordlist_t *list, wordlist_t *other, int fdout);
extern int get_token(void);
extern void lexer_stream_mode(void);
extern bogostat_t *bogofilter(int fd);
extern void logprintf(const char *fmt, ... );
extern void statdump(const bogostat_t *pb, int fd);

extern wordlist_t good_list, bad_list;

extern int byte_stuffed;

// lexer interface
#define TOKEN	1	// Ordinary token
#define FROM	2	// Mail message delimiter
extern FILE	*yyin;
extern char *yytext;

// end
